<?php
/*
  QTpro
  Version 7.3.0 Phoenix

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2021 Rainer Schmied

  Released under the GNU General Public License
*/

class hook_admin_orders_ordQtPro {

  public $version = '7.3.0';

  function listen_preAction() {

    if ( isset($GLOBALS['action']) && 'deleteconfirm' === $GLOBALS['action'] && $_POST['restock'] == 'on') {

      $oID = (int)($_GET['oID']);
      $order_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT products_id, products_quantity, products_stock_attributes 
  FROM orders_products 
  WHERE orders_id = %s
EOSQL
      , (int)$oID));

      while ( $order = $order_query->fetch_assoc() ) {
        $product_stock_adjust = 0;
        if (!empty($order['products_stock_attributes'])) {
          if ($order['products_stock_attributes'] != '$$DOWNLOAD$$') {
            $attributes_stock_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT products_stock_quantity 
  FROM products_stock 
  WHERE products_stock_attributes = '%s' 
    AND products_id = %s
EOSQL
          , $order['products_stock_attributes'], (int)$order['products_id']));    
    
            if (mysqli_num_rows($attributes_stock_query) > 0) {
              $attributes_stock_values = $attributes_stock_query->fetch_assoc();
              tep_db_query(sprintf(<<<'EOSQL'
UPDATE products_stock 
  SET products_stock_quantity = products_stock_quantity + %s 
  WHERE products_stock_attributes = '%s' 
    AND products_id = %s
EOSQL
        , (int)$order['products_quantity'], tep_db_input(Text::prepare($order['products_stock_attributes'])), (int)$order['products_id']));    
    
                $product_stock_adjust = min($order['products_quantity'],  $order['products_quantity']+$attributes_stock_values['products_stock_quantity']);
            } else {
                tep_db_query(sprintf(<<<'EOSQL'
INSERT INTO products_stock (products_id, products_stock_attributes, products_stock_quantity)
  VALUES ('%s', '%s', '%s') 
EOSQL
        , (int)$order['products_id'], tep_db_input(Text::prepare($order['products_stock_attributes'])), (int)$order['products_quantity']));    

                $product_stock_adjust = $order['products_quantity'];
            }
          }
        } else {
            $product_stock_adjust = $order['products_quantity'];
        } 
        tep_db_query(sprintf(<<<'EOSQL'
UPDATE products 
  SET products_quantity = products_quantity + %s, products_ordered = products_ordered - " . (int)$order['products_quantity'] . " 
  WHERE products_id = %s
EOSQL
        , tep_db_input(Text::prepare($product_stock_adjust)), (int)$order['products_id']));    

      }

      $_POST['restock'] = false;
    }
  }


}
